"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsSort = void 0;
const exchangeSorts_1 = __importDefault(require("./exchangeSorts"));
const selectionSorts_1 = __importDefault(require("./selectionSorts"));
const insertionSorts_1 = __importDefault(require("./insertionSorts"));
const mergeSorts_1 = __importDefault(require("./mergeSorts"));
const distributionSorts_1 = __importDefault(require("./distributionSorts"));
/*
 * JavaScript Built-in sorting
 *
 * Comparison (will vary, use for relative comparison only)
 *   100 items 0.168ms
 *   1000 items 0.46ms
 *   10000 items 4.45ms
 *   100000 items 39.621ms
 *   1000000 items 358.801ms
 */
function jsSort(arr) {
    const arrayCopy = [...arr];
    return arrayCopy.sort(function (a, b) {
        return a - b;
    });
}
exports.jsSort = jsSort;
const sorters = {
    jsSort,
    exchangeSorts: exchangeSorts_1.default,
    selectionSorts: selectionSorts_1.default,
    insertionSorts: insertionSorts_1.default,
    mergeSorts: mergeSorts_1.default,
    distributionSorts: distributionSorts_1.default,
};
exports.default = sorters;
