/**
 * Swap
 * Swaps places of two items an in array
 */
export interface ISwap {
    array: number[];
    index1: number;
    index2: number;
}
export declare function swap({ array, index1, index2 }: ISwap): void;
export interface IPivot {
    array: number[];
    start: number;
    end?: number;
}
export declare function pivot({ array, start, end, }: IPivot): number;
/**
 * Heapify
 * Traverses the elements of an array (from back to front)
 * and uses shiftDown to arrange the numbers according to an
 * max heap structure.
 */
export declare function heapify(arr: number[]): void;
/**
 * Shift Down
 * Traverses an set of an array and organizes the numbers in
 * the order of a max heap structure (parent larger than
 * children).
 */
export declare function shiftDown(arr: number[], start: number, end: number): void;
/**
 * Heapify Recursive
 * Does the same as heapify and shiftDown together, but
 * in a recursive manner
 */
export declare function heapify_recursive(arr: number[], length: number, i: number): number[];
/**
 * Get Digit
 * Returns the digit at the index of a number
 * Ex: getDigit(4321, 0) returns 4
 */
export interface IGetDigit {
    num: number;
    place: number;
}
export declare function getDigit({ num, place }: IGetDigit): number;
/**
 * Digit Count
 * Counts the number of digits in a number
 */
export declare function digitCount(num: number): number;
/**
 * Most Digits
 * Finds the number with the most digits in an array
 */
export declare function findMostDigitsFromNumbers(array: number[]): number;
export declare function newGap(gap: number): number;
